-- globals.lua kinda works like a database of reusable variables
-- images, strings etc.
TOPBG = Graphics.loadImage("romfs:/gfx/menus/loading.png")
BOTTOMBG = Graphics.loadImage("romfs:/gfx/menus/loading2.png")
BGSCR = 0
CHUNKDATA = ""

cBGM = ""
sndt = 0

-- Strings are predefined this time... hope thats enough
BACKGROUNDS = {
	"romfs:/gfx/menus/loading.png",
	"romfs:/gfx/menus/mainmenu.png",
	"romfs:/gfx/menus/library.png",
	"romfs:/gfx/menus/menucafe.png",
	"romfs:/gfx/menus/bedroom.png",
	"romfs:/gfx/menus/ovwa.png",
	
	"romfs:/gfx/menus/loading2.png",
	"romfs:/gfx/menus/mainmenu2.png",
	"romfs:/gfx/menus/ovwb.png",
	"romfs:/gfx/menus/ingamemenu.png",
	"romfs:/gfx/menus/selector.png",
	"romfs:/gfx/menus/bedroom.png",
	"romfs:/gfx/menus/creditsbook.png",
	"romfs:/gfx/menus/menucafe2.png",
	
	"romfs:/gfx/backgrounds/citybg0.png"
}

COSTUMES = {
	"romfs:/gfx/menus/costume1.png",
	"romfs:/gfx/menus/costume2.png",
	"romfs:/gfx/menus/costume3.png",
	"romfs:/gfx/menus/costume4.png",
	"romfs:/gfx/menus/costume5.png",
	"romfs:/gfx/menus/costume6.png",
	"romfs:/gfx/menus/costume7.png",
	
	"romfs:/gfx/spritesheets/player/outfit1.png",
	"romfs:/gfx/spritesheets/player/outfit2.png",
	"romfs:/gfx/spritesheets/player/outfit3.png",
	"romfs:/gfx/spritesheets/player/outfit4.png",
	"romfs:/gfx/spritesheets/player/outfit5.png",
	"romfs:/gfx/spritesheets/player/outfit6.png",
	"romfs:/gfx/spritesheets/player/outfit7.png"
}

ELEMENTS = {
	"romfs:/gfx/menus/cherrycake.png",
	"romfs:/gfx/menus/titlename.png",
	"romfs:/gfx/menus/ov_selection.png",
	"romfs:/gfx/spritesheets/ovui.png",
	"romfs:/gfx/spritesheets/costumeIcons.png",
	"romfs:/gfx/spritesheets/citytiles.png",
	"romfs:/gfx/spritesheets/hp.png",
	
	"bugs: ",
	"soda: ",
	"keychains: ",
	
	"romfs:/gfx/menus/waitressexpressions.png"
}

SELTEXT = {
	"cafe",
	"explore the city",
	"mia's home",
	"library",
	"exit to title",
	"#"
}

-- The things Clara has to say
CSM = 2
SMALLTALK = {
	-- normal expression
	"sry mia, i don't give stuff for free",
	"welcome to the cafe",
	"welcome back mia",
	"hey how's it going",
	"wait, i'm almost ready",
	"found some soda for me?",
	"nice of you to visit me that often",
	-- happy expression
	"someday i'll have my own cafe",
	"flying boxes? i need to see this",
	"keychains? i love them",
	"try the cafe-clothes, they're great",
	-- winking expression
	"shouldn't you do your homework?",
	"saved some cake for you...",
	"i don't even drink coffee",
	"costumes are in my locker",
	-- smug expression
	"i nicked some cake while the boss was busy",
	"java nice day",
	"cake-calories already burned? hehe",
	-- angy expression
	"ugh, salt instead of sugar...",
	"it was just a bit of glue",
	"... i don't wanna talk about it",
}

-- the descriptions visible in the "cafe-screen"
COSTUMEDESC = {
	"mia's standard",
	"clothes",
	"unlocked by",
	"the start",
	"bugcatcher-costume",
	"~looks silly~",
	"unlockable for",
	"20 bugs",
	"witch-costume",
	"~lots of glitter~",
	"unlockable for",
	"25 keychains",
	"cafe-clothes",
	"~so fluffy~",
	"unlockable for",
	"10 soda",
	"retro-cosplay",
	"~includes facepaint~",
	"unlockable for",
	"40 bugs",
	"modern suit",
	"~running in this?~",
	"unlockable for",
	"40 keychains",
	"debug text"
}



-- ------------------------------------------------------

S_HIGHSCORE = ""
S_BUGS = ""
S_SODA = ""
S_KEYCHAINS = ""

-- variables used in citystate
STEPS = 0 -- reset after use
AKCOSTUME = 1
AKPVAL = 1
TICTIMER = 0
ONGROUND = false
JUMPING = false
VELO = 1.0
DX = 0
DY = 0
MV = 0

TESTVAR = 0

HIGHSCORE = 0
HP = 3
BUGS = 0
SODA = 0
KEYCHAINS = 0
UNLOCKED = {1, 0, 0, 0, 0, 0}
COFFEE = false
CAKEEATEN = false

GRIDWIDTH = 12
GRIDHEIGHT = 7

PASSWORD = ""
NPWD = ""
PASSCODES = { -- plaintext... can't be bothered
	"CCDA",
	"CFFE",
	"FRGH",
	"ODSC",
	"BSNS",
	"NRDY",
	"CLRA",
	"MMIA",
	"DNWL",
	"BERP",
	"PGRM",
	"WTCH",
	"VRS3",
	"HALP",
	"4LTR",
	"PWRD",
	"L33T",
	"GMBA",
	"COZY",
	"QYZC",
	"BRCK",
	"HTML",
	"QWER",
	"0X00",
	"ULHD",
	"POPS",
	"AARG",
	"ALMT",
	"JLSR",
	"ZAZZ",
	"THNX"
}

-- creates a 12x7 array
grid = {}
for i = 1, GRIDWIDTH do
    grid[i] = {}

    for j = 1, GRIDHEIGHT do
        if(j == 7) then
			grid[i][j] = 2
		else
			grid[i][j] = 0
		end
    end
end

-- screendimensions

SCREENWIDTH = 400
SCREENHEIGHT = 240
TOUCHWIDTH = 320

-- colors

c_black = Color.new(0, 0, 0)
c_white = Color.new(255, 255, 255)

-- control variables
-- up, down, left, right, start, select, A, B, X, Y
CTRLS = {0, 0, 0, 0, 0, 0, 0, 0, 0, 0}
A_CLICKED = false
B_CLICKED = false
-- released needs to be reset after use
A_RELEASED = false
B_RELEASED = false

-- Image-variables generically named for reuse
UIELEMENT1 = Graphics.loadImage("romfs:/gfx/cherrycake.png")
UIELEMENT2 = Graphics.loadImage("romfs:/gfx/cherrycake.png")
PLAYERGFX = Graphics.loadImage("romfs:/gfx/cherrycake.png")

-- !!!! NAMED UIPOSITIONS EVEN THOUGH THEY ARE USED AS PLAYER-VARS ETC. !!!!
-- maximum amount of "UI-Elements" is 15
uiPositions = {
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0},
	{0, 0, 0, 0, 0, 0}
}

-- Background music
BGM1 = nil
BGM2 = nil
BGM3 = nil

-- Tileset (i won't add another one, but feel free to change it inside "city.lua")
TILESET = Graphics.loadImage("romfs:/gfx/cherrycake.png")

-- is the current state initialized?
INITIALIZED = false

-- Timer
aniTimer = Timer.new()
inputTimer = Timer.new()
prgEndTimer = Timer.new()
Timer.pause(prgEndTimer)