-- GPU ready
Graphics.init()



-- 3D ready
Screen.enable3D()

-- new 3ds
System.setCpuSpeed(NEW_3DS_CLOCK)

-- setup pad
pad = Controls.read()
oldpad = Controls.read()

-- Enable sound
Sound.init()

-- initialize rng
math.randomseed(os.time())
math.random(); math.random(); math.random() -- shuffle

dofile("romfs:/Jukebox.lua")

-- reused variables and controls
dofile("romfs:/imagefont.lua")

-- reused variables and controls
dofile("romfs:/globals.lua")

-- initialize global-functions
dofile("romfs:/usefulfunctions.lua")

-- initialize controls for states
dofile("romfs:/s_controls.lua")

osh, osm, oss = System.getTime()

-- states
local s_loading = loadfile("romfs:/states/loading.lua")
local s_title = loadfile("romfs:/states/title.lua")
local s_ovw = loadfile("romfs:/states/overworld.lua")
local s_cafe = loadfile("romfs:/states/cafe.lua")
local s_library = loadfile("romfs:/states/library.lua")
local s_city = loadfile("romfs:/states/city.lua")
local s_home = loadfile("romfs:/states/home.lua")

-- state-controller
flag = 0
firstInit = true

-- Gameloop starts here
while true do
	
	firstInit = false
	
	Sound.updateStream()
	collectgarbage("collect")
	
	Screen.refresh()
	
	pad = Controls.read()
	c_controls()
	
	-- Statehandler --
	-- variables called as functions...
	-- dunno why, but LPP seems to run better with it
	if(uiPositions[10][1] ~= -99) then
		if(flag == 0) then
			s_loading()
		end
		if(flag == 1) then
			s_title()
		end
		if(flag == 2) then
			s_ovw()
		end
		if(flag == 3) then
			s_cafe()
		end
		if(flag == 4) then
			s_library()
		end
		if(flag == 5) then
			s_city()
		end
		if(flag == 6) then
			s_home()
		end
	else
		
	end
	-- ------------ --
	
	Graphics.flip()
	
	resetControls()
	
	-- gc runs now on every refresh
	-- seems to get rid of string-creation
	-- memory leak
	--collectgarbage()
	
	--Sound.updateStream()
	
	if(Controls.check(pad, KEY_HOME)) then
		uiPositions[10][1] = -99
		Timer.resume(prgEndTimer)
		Sound.pause(BGM1)
		Sound.pause(BGM2)
		
		Sound.close(BGM1)
		Sound.close(BGM2)
	end
	
	if(Timer.getTime(prgEndTimer) > 600) then
		Sound.term()
		
		Graphics.freeImage(PLAYERGFX)
		Graphics.freeImage(UIELEMENT2)
		Graphics.freeImage(UIELEMENT1)
		Graphics.freeImage(TOPBG)
		Graphics.freeImage(BOTTOMBG)
		
		System.exit()
	end
	
	Screen.waitVblankStart()
end