-- ------------ Init --------------------
if(not INITIALIZED) then
	
	Graphics.freeImage(TOPBG)
	TOPBG = Graphics.loadImage(BACKGROUNDS[15])
	Graphics.freeImage(BOTTOMBG)
	BOTTOMBG = Graphics.loadImage(BACKGROUNDS[10])
	
	-- ------------- CITY-SPECIFIC ----------------------
	
	Graphics.freeImage(PLAYERGFX)
	PLAYERGFX = Graphics.loadImage(COSTUMES[AKCOSTUME+7])
	AKPVAL = 1
	VELO = 1
	
	if(CAKEEATEN) then
		CAKEEATEN = false
		HP = HP + 1
	end
	
	if(COFFEE) then
		COFFEE = false
		-- TODO coffee speedup
	end
	
	for i = 1, GRIDWIDTH do
    grid[i] = {}

    for j = 1, GRIDHEIGHT do
        if(j == 7) then
			grid[i][j] = 2
		else
			grid[i][j] = 0
		end
		end
	end
	
	-- spritesheet for the city
	UIELEMENT1 = Graphics.loadImage(ELEMENTS[6])
	UIELEMENT2 = Graphics.loadImage(ELEMENTS[7])
	
	uiPositions[1][1] = 0 -- tile-x
	uiPositions[1][2] = 0 -- tile-y
	
	uiPositions[1][3] = 0 -- ix
	uiPositions[1][4] = 0 -- iy
	
	uiPositions[1][5] = 64 -- exact player x
	uiPositions[1][6] = 64 -- exact player y
	
	uiPositions[2][1] = 0 -- next player position
	
	uiPositions[2][2] = 0 -- current Block-Animation
	uiPositions[2][3] = 0 -- out of bounds check
	
	uiPositions[2][4] = 1 -- unused
	
	uiPositions[3][1] = -1
	uiPositions[3][2] = 0
	uiPositions[3][3] = 96
	uiPositions[3][4] = 0 -- Item-collected animation
	
	-- map-builder
	uiPositions[3][5] = 0 -- akchunk
	uiPositions[3][6] = 0 -- akrow
	
	uiPositions[4][1] = EFTPSZ/84
	
	uiPositions[4][2] = 0 -- spd up
	uiPositions[4][3] = 0
	
	Timer.reset(aniTimer)
	Timer.resume(aniTimer)
	
	Timer.reset(inputTimer)
	Timer.resume(inputTimer)
	
	-- --------------------------------------------------
	BGM2 = Sound.openOgg("romfs:/bgm/action.ogg", true)
	Sound.play(BGM2,LOOP)
	
	INITIALIZED = true
end

-- --------- LEFT-Screen ----------------
Graphics.initBlend(TOP_SCREEN, LEFT_EYE)
Graphics.drawImage(-2-math.floor(BGSCR), 0, TOPBG)
Graphics.drawImage(-2-math.floor(BGSCR)+SCREENWIDTH, 0, TOPBG)

-- mostly unused -> debug values here
--drawString(16, 16, "xtl.: "..uiPositions[1][1])
--drawString(16, 24, "ytl.: "..uiPositions[1][2])
--drawString(16, 32, "velo: "..VELO)
--drawString(16, 40, "ongn: "..tostring(ONGROUND))
--drawString(16, 48, "xpos: "..uiPositions[1][5])
--drawString(16, 56, "ypos: "..uiPositions[1][6])
--drawString(16, 64, "xoff: "..DX)
--drawString(16, 72, "yoff: "..DY)
--drawString(16, 82, "tstv: "..TESTVAR)

for i=1, GRIDWIDTH do
	for j=1, GRIDHEIGHT do
		if(grid[i][j] == 1) then
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0, 0, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 2) then
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0, 128, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 3) then -- 3 -> Bug
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0+uiPositions[2][2], 32, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 4) then -- 4 -> Soda
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0+uiPositions[2][2], 64, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 5) then -- 5 -> Keychain
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0+uiPositions[2][2], 96, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 6) then -- 6 -> Bin
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0+uiPositions[2][2], 160, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 7) then -- 7 -- Bush
			Graphics.drawPartialImage(1+i*32-STEPS-32, j*32-32, 160, 0, 32, 32, UIELEMENT1)
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 160, 32, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 8) then -- 8 -- Streetlamp
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-96, 160, 64, 32, 96, UIELEMENT1)
		elseif(grid[i][j] == 9) then
			Graphics.fillRect(1+i*32-STEPS,1+i*32-STEPS+32,j*32-32,j*32,c_black)
		end
	end
end

Graphics.drawPartialImage((uiPositions[3][1]*32-STEPS)-1, uiPositions[3][2]*32-32, uiPositions[3][3], uiPositions[3][4], 32, 32, UIELEMENT1)

--Graphics.drawPartialImage(uiPositions[1][1]*32-66+uiPositions[1][5], uiPositions[1][2]*32-64-uiPositions[1][6], uiPositions[1][3], uiPositions[1][4], 64, 64, PLAYERGFX)

if(uiPositions[2][4] == 1) then
	Graphics.drawPartialImage(DX+uiPositions[1][1]*32-28, DY+uiPositions[1][2]*32-32, uiPositions[1][3], uiPositions[1][4], 64, 64, PLAYERGFX)
end

Graphics.fillRect(0, 32, 0, SCREENHEIGHT, c_black)
Graphics.fillRect(SCREENWIDTH-32, SCREENWIDTH, 0, SCREENHEIGHT, c_black)

Graphics.drawPartialImage(4, 4, 0, 0, HP*16, 16, UIELEMENT2)

Graphics.termBlend()

-- --------- RIGHT-Screen ------------------------------
Graphics.initBlend(TOP_SCREEN, RIGHT_EYE)
Graphics.drawImage(2-math.floor(BGSCR), 0, TOPBG)
Graphics.drawImage(2-math.floor(BGSCR)+SCREENWIDTH, 0, TOPBG)
for i=1, GRIDWIDTH do
	for j=1, GRIDHEIGHT do
		if(grid[i][j] == 1) then
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0, 0, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 2) then
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0, 128, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 3) then -- 3 -> Bug
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0+uiPositions[2][2], 32, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 4) then -- 4 -> Soda
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0+uiPositions[2][2], 64, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 5) then -- 5 -> Keychain
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0+uiPositions[2][2], 96, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 6) then -- 6 -> Bin
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 0+uiPositions[2][2], 160, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 7) then -- 7 -- Bush
			Graphics.drawPartialImage(1+i*32-STEPS-32, j*32-32, 160, 0, 32, 32, UIELEMENT1)
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-32, 160, 32, 32, 32, UIELEMENT1)
		elseif(grid[i][j] == 8) then -- 8 -- Streetlamp
			Graphics.drawPartialImage(1+i*32-STEPS, j*32-96, 160, 64, 32, 96, UIELEMENT1)
		elseif(grid[i][j] == 9) then
			Graphics.fillRect(1+i*32-STEPS,1+i*32-STEPS+32,j*32-32,j*32,c_black)
		end
	end
end

Graphics.drawPartialImage((uiPositions[3][1]*32-STEPS)+1, uiPositions[3][2]*32-32, uiPositions[3][3], uiPositions[3][4], 32, 32, UIELEMENT1)

--Graphics.drawPartialImage(uiPositions[1][1]*32-66+uiPositions[1][5], uiPositions[1][2]*32-64-uiPositions[1][6], uiPositions[1][3], uiPositions[1][4], 64, 64, PLAYERGFX)

if(uiPositions[2][4] == 1) then
	Graphics.drawPartialImage(DX+uiPositions[1][1]*32-28, DY+uiPositions[1][2]*32-32, uiPositions[1][3], uiPositions[1][4], 64, 64, PLAYERGFX)
end

Graphics.fillRect(0, 32, 0, SCREENHEIGHT, c_black)
Graphics.fillRect(SCREENWIDTH-32, SCREENWIDTH, 0, SCREENHEIGHT, c_black)

Graphics.drawPartialImage(4, 4, 0, 0, HP*16, 16, UIELEMENT2)

Graphics.termBlend()

-- -------- BOTTOM-Screen ------------------------------
Graphics.initBlend(BOTTOM_SCREEN)
Graphics.drawImage(0, 0, BOTTOMBG)
Graphics.termBlend()

-- ---------- state functions --------------------------

-- rounds tile-position to an integer
-- ----------------------------------
-- math.floor(player-position / tile-size)
uiPositions[1][1] = math.floor(uiPositions[1][5] / 32)
uiPositions[1][2] = math.floor(uiPositions[1][6] / 32)

-- offset to draw the player on the correct position
DX = uiPositions[1][5] % 32
DY = uiPositions[1][6] % 32

-- CTRLS[3] == 1

-- ----- check for game over, or out of bounds --------
if(uiPositions[1][1] < 0 or uiPositions[1][2] > GRIDHEIGHT+1) then
	resetButtons()
	resetControls()
	pad = oldpad
	Graphics.freeImage(UIELEMENT1)
	Graphics.freeImage(UIELEMENT2)
	HP = 3
	
	Sound.pause(BGM2)
	Sound.close(BGM2)
	
	quitBGM()
	CSM = math.random(3,#SMALLTALK)
	CAKEEATEN = false
	COFFEE = false
	flag = 2
	INITIALIZED = false
end

-- --------- player controls --------------------------

if(CTRLS[3] == 1) then
	uiPositions[1][5] = uiPositions[1][5]-3
	MV = -2
elseif(CTRLS[4] == 1) then
	if(uiPositions[1][5]+64 < SCREENWIDTH) then
		uiPositions[1][5] = uiPositions[1][5]+1
		MV = 2
	end
end

-- --------- speed up once -------------------------------

if(uiPositions[4][2] >= 2000 and uiPositions[4][3] == 0) then
	uiPositions[4][3] = 1
end

-- --------- apply gravity -------------------------------
VELO = VELO + 0.1

ONGROUND = false

if(VELO < 0) then
	JUMPING = true
else
	JUMPING = false
end

-- ----------------- grid collisions -----------------------
-- Catastrophe, but at least it works
for i=1, GRIDWIDTH do
	for j=1, GRIDHEIGHT do
		-- for every grid-element
		
		-- --------------- BLOCKS ---------------------------
		if((grid[i][j] == 1 and (AKPVAL == 1 or AKPVAL == 2)) or grid[i][j] == 2) then
			if(uiPositions[1][5] + 32 >= i*32-STEPS and
				uiPositions[1][5] <= i*32+32-STEPS) then
				if(uiPositions[1][6]+62 >= j*32 and
					uiPositions[1][6]+2 < j*32) then
					
				if(MV < 0) then
					uiPositions[1][5] = uiPositions[1][5]+(3+uiPositions[4][3])
					MV = 0
				elseif(MV > 0) then
					--uiPositions[1][5] = i*32-(32+STEPS)
					uiPositions[1][5] = uiPositions[1][5]-(3+uiPositions[4][3])
					uiPositions[1][4] = 256
					MV = 0
				else
					uiPositions[1][5] = uiPositions[1][5]-(3+uiPositions[4][3])
				end
					
				end
			end
		end
			
		if(uiPositions[1][5] + 31 >= i*32-STEPS and
			uiPositions[1][5] <= i*32+31-STEPS) then
			if(uiPositions[1][6]+64 >= j*32 and
				uiPositions[1][6] < j*32) then
				
				-- if block collides
				-- ----------- standard-block ------------------
				if((grid[i][j] == 1 and (AKPVAL == 1 or AKPVAL == 2)) or grid[i][j] == 2) then
					if(uiPositions[1][6]+64 <= j*32+32) then
						if(not JUMPING) then
							if(Timer.getTime(inputTimer) > 600) then
								AKPVAL = 1
								uiPositions[1][4] = 0
							end
							ONGROUND = true
							if(uiPositions[1][4] == 256) then
								uiPositions[1][4] = 0
							end
							uiPositions[1][6] = j*32-64
							VELO = 0
						end
					end
				elseif(grid[i][j] == 1 and AKPVAL == 3) then
					grid[i][j] = 0
					
					uiPositions[3][1] = i
					uiPositions[3][2] = j
					uiPositions[3][3] = 128
					uiPositions[3][4] = 0
					
				-- ----------- items ---------------------------
				elseif(grid[i][j] == 3 or grid[i][j] == 4 or grid[i][j] == 5) then
					if(grid[i][j] == 3) then
						BUGS = BUGS + 1
					elseif(grid[i][j] == 4) then
						SODA = SODA + 1
					else
						KEYCHAINS = KEYCHAINS + 1
					end
					
					grid[i][j] = 0
					
					uiPositions[3][1] = i
					uiPositions[3][2] = j
					uiPositions[3][3] = 96
					uiPositions[3][4] = 0
				-- ----------- obstacle ------------------------
				elseif(grid[i][j] == 6) then
					if(HP ~= 1) then
						HP = HP - 1
						grid[i][j] = 0
						
						uiPositions[1][4] = 320
						
						uiPositions[3][1] = i
						uiPositions[3][2] = j
						uiPositions[3][3] = 64
						uiPositions[3][4] = 0
					else
						-- TODO lose here
						resetButtons()
						resetControls()
						quitBGM()
						pad = oldpad
						Graphics.freeImage(UIELEMENT1)
						Graphics.freeImage(UIELEMENT2)
						HP = 3
						
						Sound.pause(BGM2)
						Sound.close(BGM2)
						
						flag = 2
						CSM = math.random(3,#SMALLTALK)
						CAKEEATEN = false
						COFFEE = false
						INITIALIZED = false
					end
				end
			end
		end
	end
end

if(not ONGROUND) then
	uiPositions[1][6] = uiPositions[1][6]+math.floor(VELO)
end

-- -------------- Player jumps? --------------------

if(A_CLICKED) then
	A_CLICKED = false
	
	if(ONGROUND) then
		AKPVAL = 2 -- pval 2 = jump
		
		uiPositions[1][4] = 128
		
		uiPositions[1][6] = uiPositions[1][6]-2
		VELO = -3.2
		resetButtons()
	end
end

if(B_CLICKED) then
	if(Timer.getTime(inputTimer) > 600) then
		B_CLICKED = false
		
		uiPositions[1][4] = 64
		AKPVAL = 3 -- pval 3 = slide
		
		if(ONGROUND) then
			resetButtons()
		else
			VELO = 8.0
			resetButtons()
		end
		
		Timer.reset(inputTimer)
	end
end

if(CTRLS[5] == 1) then
	CTRLS[5] = 0
end

if(STEPS < 32) then
	STEPS = STEPS + 2 + uiPositions[4][3]
else
	STEPS = 1
	-- enough steps taken, move array to the left and load new part
	
	for i=1, GRIDWIDTH do
		
		local mbuild = 0
		
		for j=1, GRIDHEIGHT do
			
			if(i == GRIDWIDTH) then
				-- TODO load map
				uiPositions[3][5] = uiPositions[3][5]+1
				
				local cnww = tonumber(string.sub(CHUNKDATA, uiPositions[3][5], uiPositions[3][5]))
				
				if(cnww == 9 and COFFEE) then
					grid[i][j] = 1
				else
					grid[i][j] = cnww
				end
				
				if(uiPositions[3][5] % 84 == 0) then
					uiPositions[3][5] = (math.random(1, uiPositions[4][1]))*84-84
				end
			else
				grid[i][j] = grid[i+1][j]
			end
		end
	end
	
end

if(BGSCR < SCREENWIDTH) then
	BGSCR = BGSCR+1.1+(uiPositions[4][3]/2)
else
	BGSCR = 0
end

uiPositions[4][2] = uiPositions[4][2]+1

-- -------------- animations -----------------------------
if(Timer.getTime(aniTimer) >= 150) then
	Timer.reset(aniTimer)
	
	if(uiPositions[1][3] == 192) then
		uiPositions[1][3] = 0
	else
		uiPositions[1][3] = uiPositions[1][3] + 64
	end
	
	if(uiPositions[2][2] == 0) then
		uiPositions[2][2] = 32
	else
		uiPositions[2][2] = 0
	end
	
	if(uiPositions[3][4] ~= 128) then
		uiPositions[3][4] = uiPositions[3][4] + 32
	end
end