-- This time only segmented by comments
-- ------------ Init --------------------
if(not INITIALIZED) then
	
	Graphics.freeImage(TOPBG)
	TOPBG = Graphics.loadImage(BACKGROUNDS[5])
	Graphics.freeImage(BOTTOMBG)
	BOTTOMBG = Graphics.loadImage(BACKGROUNDS[9])
	
	INITIALIZED = true
	uiPositions[1][1] = 0
	uiPositions[1][2] = {0,0}
	
	local foundpw = false
	local npw = 0
	
	for i=1, #PASSCODES do
		npw = i
		local akbits = toBits(i, 5)
		
		for j=1, #akbits do -- test every "bit"
			
			if(UNLOCKED[j+1] == akbits[j]) then
				if(j == #akbits) then
					foundpw = true
				end
			else
				break -- skip current passcode
			end
			
			if(foundpw) then
				break;
			end
			
		end
		
		if(foundpw) then
			break;
		end
	end
	
	if(foundpw) then
		NPWD = string.lower(PASSCODES[npw])
	else
		NPWD = "none"
	end
	
end

-- --------- LEFT-Screen ----------------
Graphics.initBlend(TOP_SCREEN, LEFT_EYE)
Graphics.drawImage(0, 0, TOPBG)

Graphics.termBlend()

-- --------- RIGHT-Screen ---------------
Graphics.initBlend(TOP_SCREEN, RIGHT_EYE)
Graphics.drawImage(0, 0, TOPBG)
Graphics.termBlend()

-- -------- BOTTOM-Screen ---------------
Graphics.initBlend(BOTTOM_SCREEN)
Graphics.drawImage(0, 0, BOTTOMBG)
drawString(24, 24, "press ~start~ to enter a password");
drawString(24, 34, "press ~b~ to go back")

--drawString(24, 54, "unlocked: "..table.concat(UNLOCKED))

drawString(24, 64, "current password: "..NPWD)

Graphics.termBlend()

-- ---------- Controls ------------------

if(CTRLS[5] > 0 and uiPositions[1][1] == 0) then
	PASSWORD = System.startKeyboard("");
	pad = oldpad
	uiPositions[1][1] = 1
end

if(B_RELEASED) then
	resetButtons()
	INITIALIZED = false
	flag = 2
end

if(uiPositions[1][1] == 1) then
	uiPositions[1][1] = 0
	
	for i=1, #PASSCODES do
		
		if(PASSWORD == PASSCODES[i]) then
			
			local pwd = toBits(i, 5)
			
			uiPositions[1][2] = pwd
			
			for j=1, #pwd do
				
				UNLOCKED[j+1] = pwd[j]
			
			end
			
		end
		
	end
end